// lpac_codec_api.h - header file for lpac_codec_api.cpp
// (c) Tilman Liebchen
// 02.02.2001

// This header file can be used either for export (into a DLL, if LPAC_CODEC_API_EXPORTS is defined)
// or import (from a DLL). STATIC_CODEC is only usefull together with the source code (not supplied).
// Im importing, the use of __declspec(dllimport) is optional and can be omitted.
#ifdef STATIC_CODEC
   #define DLL_IMP_EXP
#elif defined LPAC_CODEC_API_EXPORTS
   #define DLL_IMP_EXP __declspec(dllexport)
#else
   #define DLL_IMP_EXP __declspec(dllimport)
#endif

// this structure contains retrieved PAC file information
typedef struct
{
	short frame;
	short ver;
	short ra;
	short poly;
	short js;
	short ap;
	short aq;
	short res;
	short ch;
	long num;
	long freq;
	long wsize;
	long psize;
}
PACINFO;

// function declarations
extern "C" 
{
DLL_IMP_EXP short EncodeWaveFile(const char *WavName, const char *PacName, short Version, short CompMode, short Joint, short RA);
DLL_IMP_EXP short EncoderCreate();
DLL_IMP_EXP short EncoderOpenFiles(const char *WavName, const char *PacName);
DLL_IMP_EXP short EncoderCloseFiles();
DLL_IMP_EXP short EncoderSetFiles(FILE *fpWave, FILE *fpPac);
DLL_IMP_EXP short EncoderDelete();
DLL_IMP_EXP short EncoderSetVersion(short Version);
DLL_IMP_EXP short EncoderSetCompMode(short CompMode);
DLL_IMP_EXP short EncoderSetJoint(short Joint);
DLL_IMP_EXP short EncoderSetRA(short RA);
DLL_IMP_EXP short EncodeFile();
DLL_IMP_EXP long EncodeHeader();
DLL_IMP_EXP short EncodeFrame();
DLL_IMP_EXP short EncodeRemains();
DLL_IMP_EXP short DecodePacFile(const char *PacName, const char *WavName);
DLL_IMP_EXP short DecoderCreate();
DLL_IMP_EXP short DecoderOpenFiles(const char *name1, const char *name2);
DLL_IMP_EXP short DecoderCloseFiles();
DLL_IMP_EXP short DecoderSetFiles(FILE *fpPac, FILE *fpWav);
DLL_IMP_EXP short DecoderDelete();
DLL_IMP_EXP short DecodeFile();
DLL_IMP_EXP long DecodeHeader();
DLL_IMP_EXP short DecodeFrame();
DLL_IMP_EXP short DecodeRemains();
DLL_IMP_EXP short DecoderGetInfo(PACINFO *info);
DLL_IMP_EXP const void *DecoderGetAudioBuffer();
DLL_IMP_EXP short GetPacFileInfo(const char *name, PACINFO *info);
}
